/*
 * ottmar: an ambient gmail display
 * by stephan.com
 * image by ottmar liebert http://www.lunanegra.com/www/ol_main.htm
 * creative commons Attribution-NonCommercial 2.0 license
 * based on flores
 */
 
/*
 * A note on authentication.  It's a funny thing...  and took me a while to figure out.
 * You have to log in through gmail, AND authenticate with user/password in the URL
 * from Dashboard.  If you're not logged in, it doesn't work.  If you don't give the
 * username/password, it doesn't work.
 *
 * Kinda sucks, I wanted to have multiple instantiations for multiple accounts :(
 * or at least not require login.
 * it'd also be real nice to tell the difference between "not logged in" and "no email"
 * but, oh well.
 */

var req;
var unread = -1;
/*
 * At first glance, the update frequency seems unabashedly slow, but since we ALSO
 * reload every time the user fires up dashboard, it's actually not bad at all
 */
var updateFrequency = 5 * 60000; // every 5 minutes (but only when Dashboard is visible)

var username = '';
var password = '';
var filterType = "none";
var filter='stephan';
var GmailURL = 'http://mail.google.com/';
var numElements = 4;
var mailType = "";

var debugEnabled = false;	
var adjust_closebox = true; // not sure if this is a good idea or not
var refreshInterval;

// Utility function for debugging.  When in Dashboard, alerts go to console.

function debug(text) {	 
    if (debugEnabled) {	 
        alert(text);	 
    }	 
}

// Go to the site--different if you're testing in a browser vs. in Dashboard.

function gotoGmail() {
	if (window.widget) {
		if(mailType=="apple") {
			widget.openApplication("mail");
		} else {
			widget.openURL(GmailURL);
		}
	} else {
		window.location.href = GmailURL;
	}
}

function gotoURL(url) {
	if (window.widget) {
		widget.openURL(url);
	} else {
		window.location.href = url;
	}
}

// Creates an instance-specific version of a key for persistent
// Dashboard state storage.

function createkey(key)
{
	return widget.identifier + "-" + key;
}

// If Enter key is pressed on the flip side, flip back to front.

function handleEnter() {
    var keyCode = event.keyCode ? event.keyCode : event.which ? event.which : event.charCode;
    if (keyCode == 13) {
        hidePrefs();
    }
}


// same thing, but for level 2 prefs
function handleEnter2() {
    var keyCode = event.keyCode ? event.keyCode : event.which ? event.which : event.charCode;
    if (keyCode == 13) {
        hidePrefs2();
    }
}


// Button states are both in the same image, and are swapped by changing
// the clipping area.  Call pressButton(element ID) when a button is pressed,
// and releaseButton(element ID) when it's released.

function pressButton(id) {
    document.getElementById(id).style.backgroundPosition = '0px -21px'; 
}

function releaseButton(id) {
    document.getElementById(id).style.backgroundPosition = '0px 0px'; 
}

// Perform the flip from front to back.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	} 
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back

	if (adjust_closebox && window.widget) {
	    widget.setCloseBoxOffset(0,0);
	}

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);	// and flip the widget over	
		window.resizeTo(120,145);
	}
}

function setMailType(which) {
debug("mail type"+which);
	var gmailButton = document.getElementById("gmailPrefsButton");
	var appleButton = document.getElementById("applePrefsButton");

	if(which=="apple") {
		appleButton.style.background = "#ACE539";
		appleButton.style.color = "black";
		gmailButton.style.background = "#99CC33";
		gmailButton.style.color = "white";

		mailType = "apple";
	} else {
		gmailButton.style.background = "#ACE539";
		gmailButton.style.color = "black";
		appleButton.style.background = "#99CC33";
		appleButton.style.color = "white";

		mailType = "gmail";
	}
}

function getMailType() {
	return mailType;
}

function gotoGmailPrefs()
{

	var front = document.getElementById("back");
	var back = document.getElementById("gmailPrefs");
	
	setMailType("gmail");
	
	// set button states

	if (window.widget) {
		window.resizeTo(120,145);
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	}
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back

	txt = document.getElementById("usernameField");
    txt.focus();  // so you can start typing right away
	
	if (adjust_closebox && window.widget) {
	    widget.setCloseBoxOffset(0,0);
	}

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);	// and flip the widget over	
	}
}

function gotoApplePrefs()
{
	setMailType("apple");
}

// hide level 2 prefs
function hidePrefs2()
{
	var front = document.getElementById("back");
	var back = document.getElementById("gmailPrefs");


// well isn't that funny.  This should really be a ToFront transition,
// but it doesn't work that way.  I think Apple won't let you do two ToFront's in a row.
// I wonder if that was
// 1 Design choice because you're flipping between two backs
// 2 Design choice to prevent two levels deep - but the bug is they all two TwoBack's in a row
// 3 Just a bug
	if (window.widget) {
		window.resizeTo(120,145);
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	}
	
	back.style.display="none";		// hide the front
	front.style.display="block";		// show the back
	
	if (adjust_closebox && window.widget) {
	    widget.setCloseBoxOffset(0,0);
	}

	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);	// and flip the widget over	
	}
}


// Perform the flip from back to front, refresh content under the assumption
// that the configuration has changed.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) {
		window.resizeTo(171,297);
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	}
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front

	username = document.getElementById("usernameField").value;
	password = document.getElementById("passwordField").value;
	filterType = document.getElementById("filterTypeField").value;
	filter = document.getElementById("filterField").value;
// mailType is already set

	
	if (window.widget) {
        widget.setPreferenceForKey(username, createkey("username")); // save value
        widget.setPreferenceForKey(password, createkey("password")); // save value
        widget.setPreferenceForKey(filter, createkey("filter")); // save value
        widget.setPreferenceForKey(filterType, createkey("filterType")); // save value
        widget.setPreferenceForKey(mailType, createkey("mailType"));
    }
	
	if (adjust_closebox && window.widget) {
	    widget.setCloseBoxOffset(50,200);
	}
	refreshCount();
	
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
	}
}

function processFilter()
{
	filterType = document.getElementById("filterTypeField").value;
	document.getElementById("filterTypeValue").innerHTML = filterType;
	if(filterType=="none") {
		document.getElementById("filterField").disabled=true;
		document.getElementById("filterField").value="";
	} else {
		document.getElementById("filterField").disabled=false;
		document.getElementById("filterField").value=filter;
	}
}


// setup() is called when the body of the widget is loaded.  This function places the localized
// strings into the widget.


// Divine the number of new emails from Google XML
// check if the user has set a preferred filter
// if so, count only those emails from that filter

function parseData(GmailXML) {

	newMails = GmailXML.match(/<entry>(.*?)<\/entry>/ig);

	// added (-) 03may05 0420a to fix a bug
	if(!newMails) {
		return 0; }

	// if the user has no preferred filter, then we return the total number of emails
	// doublecheck the third compare sometime, why?
	if(filterType=="none" || !filter || (filter=="undefined") )  {
			return newMails.length;
	}

	var newFromfilter=0;
	for(i=0 ; i<newMails.length ; i++) { // for each new email
		if(filterType=="name") {
			thisfilter = newMails[i].match(/<author>(.*?)<\/author>/ig);
		} else {
			thisfilter = newMails[i].match(/<title>(.*?)<\/title>/ig);
		}
			
		// gmail appears to have only one author, though multiple possible email addresses.
		// I'm not sure, though...  I going to just assume there's only one author,
		// and therefore, only worry about the first element in the thisfilter array
		// oh yeah, the search is case-insensitive, just 'cuz.
		if(thisfilter[0].toLowerCase().indexOf(filter.toLowerCase())>-1) {
			newFromfilter++;
		}
	}

	return newFromfilter;
}


// Called when the XMLHttpRequest status changes--if it's got a successful
// response, we update the display with the new value.

/*
 * interesting factoid here.  While I was fixing google's url change on 6/21,
 * I decided to screw around with parsing the DOM XML tree.  Funny thing.
 * I can get the number of new emails easily with:
 * (req.responseXML.getElementsByTagName('fullcount'))[0].firstChild.nodeValue
 * or even with one of these
 * req.responseXML.getElementsByTagName('entry').length
 * req.responseXML.getElementsByTagName('summary').length
 * req.responseXML.getElementsByTagName('author').length
 * Those all work fine.  I can get entries, summaries, author parsed out really easy, nice stuff.
 * BUT!!!  This doesn't work, and returns zero:
 * req.responseXML.getElementsByTagName('title').length
 * I'm guessing it's because <title> is a special HTML tag, and this stuff isn't meant for parsing
 * plain old XML.  This means I can't actually filter by titles in XML.  Maybe there's something I'm doing wrong, but
 * the old regexp version isn't broke, so I'm not fixing it.  I mean, I can SEE there's a <title> tag in the RSS feed.
 * In any case, I've left a nifty debug statement in there for whoever is reading this.
 */ 

function processReqChange() {
    if ((req.readyState == 4) && (req.status == 200)) {
    
    debug("This should work but doesn't: "+
    (req.responseXML.getElementsByTagName('fullcount'))[0].firstChild.nodeValue + " " +
    req.responseXML.getElementsByTagName('entry').length + " " +
	req.responseXML.getElementsByTagName('summary').length + " " +
	req.responseXML.getElementsByTagName('author').length + " " +
	req.responseXML.getElementsByTagName('title').length );
    
        unread = parseData(req.responseText);
        updateDisplay();
    }
}

/*
 * By popular demand!
 * process apple mail via applescript via the command line!
 * which sucks!
 * but whatever!
 */

function processAppleChange() {

	if(!window.widget) {
		alert("applescript not supported in Safari\n");
		return;
	}

	var script;

	if(filterType=="none" || !filter || (filter=="undefined")) {
		script = "/usr/bin/osascript -e 'tell application \"Mail\"\ncount (every message in inbox whose read status is false)\nend tell'";
	} else if(filterType=="subject") {
		script = "/usr/bin/osascript -e 'tell application \"Mail\"\ncount (every message in inbox whose read status is false and the subject contains \""+filter+"\")\nend tell'";
	} else if(filterType=="name") {
		script = "/usr/bin/osascript -e 'tell application \"Mail\"\ncount (every message in inbox whose read status is false and the sender contains \""+filter+"\")\nend tell'";
	} else {
		debug("invalid filterType in processAppleChange()");
	}

	unread = widget.system(script,null).outputString;
	updateDisplay();
}

// Start the process of updating the unread count.

function refreshCount() {
	if (window.widget) {	 
        debug('refreshing content')	;
    }

	if(mailType=="apple") {
		processAppleChange();
	} else {
	    if (!username || (username.length === 0) || !password || (password.length===0)) {
	        if (window.widget) {
	            debug('no email or password, not refreshing');
	            unread = -1;
	            return;
	        }
	    }

/*
 * 21 June 2005 - the Summer Solstice
 * google changed the RSS URL without bothering to tell anyone or even give an error message
 * They just decided to hand back an empty file at that url
 * Sweet.  NOT!
 * As long as I'm digging around in here, I also set a content-type header for safety
 * and a cache-control header to get rid of the ugly random number hack
 */

	    req = new XMLHttpRequest();
	    req.open("GET","https://"+username+":"+password+"@mail.google.com/mail/feed/atom", true);
		req.setRequestHeader("Content-Type", "text/xml");
		req.setRequestHeader("Cache-Control", "no-cache");
	    req.onreadystatechange = processReqChange;
	    req.send(null);
	 }
}

// Update the HTML content for the unread count based on the unread variable.

function updateDisplay() {
    if (window.widget) {	 
        debug('updating display to reflect ' + unread + ' unread');	 
    }
    
    thingSpace = document.getElementById("flowersPic");
    
    countElements=unread;
    if(unread<0) countElements=0;
    if(unread>numElements) countElements=numElements;
    
    thingSpace.src="o/f"+countElements+".png";
}

// We don't want the widget refreshing when it's not on the screen, so these
// functions start and stop the refresh timer.

function setRefreshTimer() {	 
    if (refreshInterval == null) {	 
        debug("setting refresh timer");	 
        refreshInterval = setInterval("refreshCount();", updateFrequency);	 
    }	 
}	 
 	 
function clearRefreshTimer() {	 
    if (refreshInterval != null) {	 
        debug("clearing refresh timer");	 
        clearInterval(refreshInterval);	 
        refreshInterval = null;
    }
}
 
function isUsernameValid() {
    return (username && (username.length > 0));
}

function isPasswordValid() {
    return (password && (password.length > 0));
}

              
function init() {

    // Attempt to retrieve saved configuration.
    if (window.widget) {
        username = widget.preferenceForKey(createkey("username"));
        if (!username || (username == "undefined")) {
            username = "";
        }
        password = widget.preferenceForKey(createkey("password"));
        if (!password || (password == "undefined")) {
            password = "";
        }
        filterType = widget.preferenceForKey(createkey("filterType"));
        if (!filterType || (filterType == "undefined")) {
            filterType = "none";
        }
        filter = widget.preferenceForKey(createkey("filter"));
        if (!filter || (filter == "undefined")) {
        	if(filterType=="none") filter = "";
        	else					 filter = filter;
        }
        mailType = widget.preferenceForKey(createkey("mailType"));
        if(!mailType || (mailType == "undefined")) {
        	setMailType("apple");
        }
    }

	if (adjust_closebox && window.widget) {
	    widget.setCloseBoxOffset(50,200);
	}

	txt = document.getElementById("usernameField");
	txt.value = username;
	txt = document.getElementById("passwordField");
	txt.value = password;
	txt = document.getElementById("filterField");
	txt.value = filter;
	txt = document.getElementById("filterTypeField");
	txt.value = filterType;
	setMailType(mailType);


	if (window.widget) {	 
        widget.onshow = function OnShow() { // when Dashboard triggered	 
            debug("widget shown");	 
            setRefreshTimer();	 
            refreshCount();	 
        }	 
        widget.onremove = function OnRemove() { // when widget discarded 
            debug("widget removed");
            widget.setPreferenceForKey(null, createkey("username"));	 
            widget.setPreferenceForKey(null, createkey("password"));	 
            widget.setPreferenceForKey(null, createkey("filter"));	 
            widget.setPreferenceForKey(null, createkey("filterType"));	 
            widget.setPreferenceForKey(null, createKey("mailType"));
            clearRefreshTimer();	 
        }	 
        widget.onhide = function OnHide() { // when Dashboard dismissed	 
            debug("widget hidden");	 
            clearRefreshTimer();	 
        }	 
    }	 
 	
    setRefreshTimer();

// hmmm, what to do about this?  Do we default to Apple Mail?  Or go to config?
// OK, if apple mail is set, then don't flip.
// if gmail is set, and there's no uname/pw, then flip
// otherwise, sit there.
// CLEAN THIS UP TO HANDLE PERVERSE CASES
	if(!mailType || (mailType=="undefined")) {
		setMailType("apple");
		showPrefs();
	} else {
		refreshCount();
	}
	
/*
    if (mailType=="gmail" && (!isUsernameValid() || !isPasswordValid())) { // go directly to config if necessary
        setTimeout ('showPrefs();', 1000); // don't interfere with ripples
        setMailType("apple");
    } else {
        refreshCount();
    }	 
    */
}

// boilerplate code for infobutton animation taken from Apple

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0,
				firstElement:null, timer:null};

function mousemove (event) {
	if (!flipShown) {
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer = null;
		}

		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit (event) {
	if (flipShown) {
		// fade in the info button
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);
	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
	return from + (to - from) * ease;
}
